VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   Caption         =   "W&T Serial HTTP-Server"
   ClientHeight    =   3315
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6165
   Icon            =   "SerHTTPSrv.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3315
   ScaleWidth      =   6165
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Timer WaitToClose 
      Enabled         =   0   'False
      Interval        =   2000
      Left            =   4920
      Top             =   1800
   End
   Begin VB.Timer DTRTimeout 
      Enabled         =   0   'False
      Interval        =   250
      Left            =   4440
      Top             =   1800
   End
   Begin VB.Timer RecTimeout 
      Enabled         =   0   'False
      Interval        =   3000
      Left            =   4440
      Top             =   2280
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   4920
      Top             =   2400
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   327680
      DTREnable       =   -1  'True
      Handshaking     =   2
      OutBufferSize   =   1024
      RThreshold      =   1
      RTSEnable       =   -1  'True
      SThreshold      =   1
   End
   Begin VB.Frame Frame1 
      Height          =   3135
      Left            =   0
      TabIndex        =   0
      Top             =   120
      Width           =   6135
      Begin VB.FileListBox File1 
         Height          =   870
         Left            =   120
         TabIndex        =   10
         Top             =   2040
         Width           =   2415
      End
      Begin VB.TextBox TextDir 
         Height          =   285
         Left            =   120
         TabIndex        =   8
         Top             =   1320
         Width           =   3975
      End
      Begin VB.TextBox TextComPara 
         Height          =   285
         Left            =   1920
         TabIndex        =   4
         Text            =   "38400,n,8,1"
         Top             =   600
         Width           =   2175
      End
      Begin VB.ComboBox Combo1 
         Height          =   315
         ItemData        =   "SerHTTPSrv.frx":0442
         Left            =   120
         List            =   "SerHTTPSrv.frx":0452
         TabIndex        =   2
         Top             =   600
         Width           =   1575
      End
      Begin VB.CommandButton CmdStartServer 
         Caption         =   "Start Server"
         Height          =   495
         Left            =   4320
         TabIndex        =   1
         Top             =   360
         Width           =   1695
      End
      Begin VB.CommandButton CmdStopServer 
         Caption         =   "Stop Server"
         Height          =   495
         Left            =   4320
         TabIndex        =   6
         Top             =   360
         Visible         =   0   'False
         Width           =   1695
      End
      Begin VB.Label Label4 
         Caption         =   "Available HTML-files:"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   1800
         Width           =   3015
      End
      Begin VB.Label Label3 
         Caption         =   "Directory:"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   1080
         Width           =   735
      End
      Begin VB.Label Label2 
         Caption         =   "Baud, parity, databits, stopbits:"
         Height          =   255
         Left            =   1920
         TabIndex        =   5
         Top             =   360
         Width           =   2175
      End
      Begin VB.Label Label1 
         Caption         =   "COM-Port:"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   360
         Width           =   855
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'(09.03.2001) Demonstration of a simple HTTP-Server working via the serial COM port
'and a W&T Com-Server 58x11/58x21 with firmware release 1.18 and higher.
'
'If the form which is included in the the file calc.html is received
'the file getresult.htm with the patched result be returned.
'
'Input in the browsers address field:
'http://[IP address Com-Server]/[filename]
'
'Based on the Com-Servers factory defaults the following additional settings must be
'made via the telnet configuration port 1111:
'Baudrate 38400, handshake option "Open/Close connection" whith DSR = ON, Local Port (TCP/UDP) = 80


Dim DummyInt As Integer
Dim DummyString As String
Dim RecDataVar As Variant
Dim CRLF As String
Dim CRLF2x As String
Dim ReplyString As Variant
Dim HTTPRequest As String
Dim RequestedData As String
Dim BytesToSend As Integer
Dim ResultReply As String
Dim HTMLHead As String
Dim HTMLEnd As String
Dim AllOptions As String
Dim Options(1 To 10) As String
Dim OptionIndex As Integer
Dim OptionVal(1 To 10) As Long
Dim Result As Long

Private Sub CmdStartServer_Click()
    MSComm1.CommPort = Combo1.ListIndex + 1 'define COM port
    MSComm1.Settings = TextComPara.Text     'baudrate, parity, data-, stopbits
    MSComm1.Handshaking = comRTS            'flowcontrol via RTS/CTS
    MSComm1.DTREnable = True                'set DTR active
    MSComm1.PortOpen = True                 'open COM port
    CmdStartServer.Visible = False
    CmdStopServer.Visible = True
    TextComPara.Enabled = False
    Combo1.Enabled = False
    TextDir.Enabled = False
    File1.Path = TextDir.Text
End Sub

Private Sub CmdStopServer_Click()
    MSComm1.PortOpen = False                'stop the http server
    CmdStopServer.Visible = False           'and close the COM port
    CmdStartServer.Visible = True
    TextComPara.Enabled = True
    Combo1.Enabled = True
    TextDir.Enabled = True
End Sub

Private Sub DTRTimeout_Timer()
    DTRTimeout.Enabled = False
    MSComm1.DTREnable = True                'set DTR to active to allow new requests
End Sub

Private Sub Form_Load()                     'initialize variables:
    DummyInt = 0
    Combo1.ListIndex = 0
    CRLF = Chr$(&HD) + Chr$(&HA)            'CRLF = end of line
    HTMLHead = "<html>" + CRLF              'html start string
    HTMLEnd = "</html>" + CRLF              'html end string
    CRLF2x = CRLF + CRLF                    'CRLFCRLF = end of the http header
    TextDir.Text = CurDir + "\"
End Sub

Private Sub MSComm1_OnComm()
Select Case MSComm1.CommEvent
    Case comEvReceive                       'event: receipt of serial data
    RecTimeout.Enabled = True               'timeout in case of http incompatible data
    RecDataVar = MSComm1.Input              'reading serial input buffer
    HTTPRequest = HTTPRequest + RecDataVar
    If Right$(HTTPRequest, 4) = CRLF2x And Left$(HTTPRequest, 3) = "GET" Then
        RecTimeout.Enabled = False
        HTTPRequest = Right$(HTTPRequest, (Len(HTTPRequest) - 5))
        Do                                                  'filter the name of the
            DummyInt = DummyInt + 1                         'requested file
            RequestedData = Left$(HTTPRequest, DummyInt)
        Loop Until Right$(RequestedData, 1) = Chr$(&H20)
        DummyInt = 0
        HTTPRequest = ""
        If Left$(RequestedData, 13) = "getresult.htm" Then
            Call CreateResultReply
        Else
            Call HTTPReply
        End If
    End If
End Select
End Sub

Private Sub HTTPReply()
    Dim Temp As String
    If Dir(TextDir.Text + RequestedData) <> "" Then
        Open TextDir.Text + RequestedData For Binary Access Read As #1          'open requested file
        BytesToSend = MSComm1.OutBufferSize                                     'and send contents
        Do Until EOF(1)
            If LOF(1) - Loc(1) <= BytesToSend Then
                BytesToSend = LOF(1) - Loc(1) + 1
            End If
            Temp = Space(BytesToSend)
            Get 1, , Temp
            MSComm1.Output = Temp
            Do
                DoEvents
            Loop Until MSComm1.OutBufferCount = 0
        Loop
        Close 1
    Else
        MSComm1.Output = "Requested file is not available"          'error message if requested file
    End If                                                          'is not available
    WaitToClose.Enabled = True
End Sub

Private Sub RecTimeout_Timer()
    RecTimeout.Enabled = False      'finish the connection in case of receiving
    WaitToClose.Enabled = True      'http incompatible data
End Sub

Private Sub WaitToClose_Timer()
    WaitToClose.Enabled = False     'finish the TCP connection after 250ms
    DTRTimeout.Enabled = True       'by setting DTR to inactive
    MSComm1.DTREnable = False       'for 250ms
End Sub

Private Sub CreateResultReply()
    AllOptions = Right$(RequestedData, (Len(RequestedData) - 14)) 'filter "getresult?"
    RequestedData = Left$(RequestedData, 13)
    For i = 1 To 10
        Options(i) = ""
    Next i
    DummyInt = 0
    i = 0
    OptionIndex = 1
    DummyString = ""
    
    Do Until DummyString = " "
        i = i + 1
        DummyString = Mid$(AllOptions, i, 1)
        'get the options which are separated with "&"
        If DummyString = "&" Then
            'get the values which are separated with "="
            OptionVal(OptionIndex) = Val(Mid$(Options(OptionIndex), 7, Len(Options(OptionIndex)) - 6))
            OptionIndex = OptionIndex + 1
            DummyString = ""
        End If
        Options(OptionIndex) = Options(OptionIndex) + DummyString
    Loop
    Result = OptionVal(1) * OptionVal(2)        'calculate result
    'and patch it to the belonging offset in getresult.htm
    Open TextDir.Text + RequestedData For Binary Access Write As #1
    Seek #1, &H258
    DummyString = Trim(OptionVal(1)) + Space(5 - Len(Trim(OptionVal(1))))
    Put 1, , DummyString
    Seek #1, &H32E
    DummyString = Trim(OptionVal(2)) + Space(5 - Len(Trim(OptionVal(2))))
    Put 1, , DummyString
    Seek #1, &H36E
    DummyString = Trim(Result) + Space(9 - Len(Trim(Result)))
    Put 1, , DummyString
    Close 1
    Call HTTPReply
End Sub
